Give commit message reencoding for output on MinGW a chance
[git/dscho.git] / git-rebase.sh
blob24a2840033c175ff5399de82a1a777c75c0e85dd
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To check out the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
26 / --> /
27 D---E---F---G master D---E---F---G master
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_KEEPDASHDASH=
32 OPTIONS_SPEC="\
33 git rebase [-i] [options] [--onto <newbase>] [<upstream>] [<branch>]
34 git rebase [-i] [options] --onto <newbase> --root [<branch>]
35 git-rebase [-i] --continue | --abort | --skip
37 Available options are
38 v,verbose! display a diffstat of what changed upstream
39 q,quiet! be quiet. implies --no-stat
40 onto=! rebase onto given branch instead of upstream
41 p,preserve-merges! try to recreate merges instead of ignoring them
42 s,strategy=! use the given merge strategy
43 no-ff! cherry-pick all commits, even if unchanged
44 m,merge! use merging strategies to rebase
45 i,interactive! let the user edit the list of commits to rebase
46 k,keep-empty preserve empty commits during rebase
47 f,force-rebase! force rebase even if branch is up to date
48 X,strategy-option=! pass the argument through to the merge strategy
49 stat! display a diffstat of what changed upstream
50 n,no-stat! do not show diffstat of what changed upstream
51 verify allow pre-rebase hook to run
52 rerere-autoupdate allow rerere to update index with resolved conflicts
53 root! rebase all reachable commits up to the root(s)
54 autosquash move commits that begin with squash!/fixup! under -i
55 committer-date-is-author-date! passed to 'git am'
56 ignore-date! passed to 'git am'
57 whitespace=! passed to 'git apply'
58 ignore-whitespace! passed to 'git apply'
59 C=! passed to 'git apply'
60 Actions:
61 continue! continue
62 abort! abort and check out the original branch
63 skip! skip current patch and continue
65 . git-sh-setup
66 set_reflog_action rebase
67 require_work_tree_exists
68 cd_to_toplevel
70 LF='
72 ok_to_skip_pre_rebase=
73 resolvemsg="
74 When you have resolved this problem run \"git rebase --continue\".
75 If you would prefer to skip this patch, instead run \"git rebase --skip\".
76 To check out the original branch and stop rebasing run \"git rebase --abort\".
78 unset onto
79 strategy=
80 strategy_opts=
81 do_merge=
82 merge_dir="$GIT_DIR"/rebase-merge
83 apply_dir="$GIT_DIR"/rebase-apply
84 verbose=
85 diffstat=
86 test "$(git config --bool rebase.stat)" = true && diffstat=t
87 git_am_opt=
88 rebase_root=
89 force_rebase=
90 allow_rerere_autoupdate=
91 # Non-empty if a rebase was in progress when 'git rebase' was invoked
92 in_progress=
93 # One of {am, merge, interactive}
94 type=
95 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
96 state_dir=
97 # One of {'', continue, skip, abort}, as parsed from command line
98 action=
99 preserve_merges=
100 autosquash=
101 keep_empty=
102 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
104 read_basic_state () {
105 head_name=$(cat "$state_dir"/head-name) &&
106 onto=$(cat "$state_dir"/onto) &&
107 # We always write to orig-head, but interactive rebase used to write to
108 # head. Fall back to reading from head to cover for the case that the
109 # user upgraded git with an ongoing interactive rebase.
110 if test -f "$state_dir"/orig-head
111 then
112 orig_head=$(cat "$state_dir"/orig-head)
113 else
114 orig_head=$(cat "$state_dir"/head)
115 fi &&
116 GIT_QUIET=$(cat "$state_dir"/quiet) &&
117 test -f "$state_dir"/verbose && verbose=t
118 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
119 test -f "$state_dir"/strategy_opts &&
120 strategy_opts="$(cat "$state_dir"/strategy_opts)"
121 test -f "$state_dir"/allow_rerere_autoupdate &&
122 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
125 write_basic_state () {
126 echo "$head_name" > "$state_dir"/head-name &&
127 echo "$onto" > "$state_dir"/onto &&
128 echo "$orig_head" > "$state_dir"/orig-head &&
129 echo "$GIT_QUIET" > "$state_dir"/quiet &&
130 test t = "$verbose" && : > "$state_dir"/verbose
131 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
132 test -n "$strategy_opts" && echo "$strategy_opts" > \
133 "$state_dir"/strategy_opts
134 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
135 "$state_dir"/allow_rerere_autoupdate
138 output () {
139 case "$verbose" in
141 output=$("$@" 2>&1 )
142 status=$?
143 test $status != 0 && printf "%s\n" "$output"
144 return $status
147 "$@"
149 esac
152 move_to_original_branch () {
153 case "$head_name" in
154 refs/*)
155 message="rebase finished: $head_name onto $onto"
156 git update-ref -m "$message" \
157 $head_name $(git rev-parse HEAD) $orig_head &&
158 git symbolic-ref \
159 -m "rebase finished: returning to $head_name" \
160 HEAD $head_name ||
161 die "Could not move back to $head_name"
163 esac
166 run_specific_rebase () {
167 if [ "$interactive_rebase" = implied ]; then
168 GIT_EDITOR=:
169 export GIT_EDITOR
171 . git-rebase--$type
174 run_pre_rebase_hook () {
175 if test -z "$ok_to_skip_pre_rebase" &&
176 test -x "$GIT_DIR/hooks/pre-rebase"
177 then
178 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
179 die "The pre-rebase hook refused to rebase."
183 test -f "$apply_dir"/applying &&
184 die 'It looks like git-am is in progress. Cannot rebase.'
186 if test -d "$apply_dir"
187 then
188 type=am
189 state_dir="$apply_dir"
190 elif test -d "$merge_dir"
191 then
192 if test -f "$merge_dir"/interactive
193 then
194 type=interactive
195 interactive_rebase=explicit
196 else
197 type=merge
199 state_dir="$merge_dir"
201 test -n "$type" && in_progress=t
203 total_argc=$#
204 while test $# != 0
206 case "$1" in
207 --no-verify)
208 ok_to_skip_pre_rebase=yes
210 --verify)
211 ok_to_skip_pre_rebase=
213 --continue|--skip|--abort)
214 test $total_argc -eq 2 || usage
215 action=${1##--}
217 --onto)
218 test 2 -le "$#" || usage
219 onto="$2"
220 shift
223 interactive_rebase=explicit
226 keep_empty=yes
229 preserve_merges=t
230 test -z "$interactive_rebase" && interactive_rebase=implied
232 --autosquash)
233 autosquash=t
235 --no-autosquash)
236 autosquash=
238 -M|-m)
239 do_merge=t
242 shift
243 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$1")"
244 do_merge=t
245 test -z "$strategy" && strategy=recursive
248 shift
249 strategy="$1"
250 do_merge=t
253 diffstat=
255 --stat)
256 diffstat=t
259 verbose=t
260 diffstat=t
261 GIT_QUIET=
264 GIT_QUIET=t
265 git_am_opt="$git_am_opt -q"
266 verbose=
267 diffstat=
269 --whitespace)
270 shift
271 git_am_opt="$git_am_opt --whitespace=$1"
272 case "$1" in
273 fix|strip)
274 force_rebase=t
276 esac
278 --ignore-whitespace)
279 git_am_opt="$git_am_opt $1"
281 --committer-date-is-author-date|--ignore-date)
282 git_am_opt="$git_am_opt $1"
283 force_rebase=t
286 shift
287 git_am_opt="$git_am_opt -C$1"
289 --root)
290 rebase_root=t
292 -f|--no-ff)
293 force_rebase=t
295 --rerere-autoupdate|--no-rerere-autoupdate)
296 allow_rerere_autoupdate="$1"
299 shift
300 break
302 esac
303 shift
304 done
305 test $# -gt 2 && usage
307 if test -n "$action"
308 then
309 test -z "$in_progress" && die "No rebase in progress?"
310 # Only interactive rebase uses detailed reflog messages
311 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
312 then
313 GIT_REFLOG_ACTION="rebase -i ($action)"
314 export GIT_REFLOG_ACTION
318 case "$action" in
319 continue)
320 # Sanity check
321 git rev-parse --verify HEAD >/dev/null ||
322 die "Cannot read HEAD"
323 git update-index --ignore-submodules --refresh &&
324 git diff-files --quiet --ignore-submodules || {
325 echo "You must edit all merge conflicts and then"
326 echo "mark them as resolved using git add"
327 exit 1
329 read_basic_state
330 run_specific_rebase
332 skip)
333 output git reset --hard HEAD || exit $?
334 read_basic_state
335 run_specific_rebase
337 abort)
338 git rerere clear
339 read_basic_state
340 case "$head_name" in
341 refs/*)
342 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
343 die "Could not move back to $head_name"
345 esac
346 output git reset --hard $orig_head
347 rm -r "$state_dir"
348 exit
350 esac
352 # Make sure no rebase is in progress
353 if test -n "$in_progress"
354 then
355 die '
356 It seems that there is already a '"${state_dir##*/}"' directory, and
357 I wonder if you are in the middle of another rebase. If that is the
358 case, please try
359 git rebase (--continue | --abort | --skip)
360 If that is not the case, please
361 rm -fr '"$state_dir"'
362 and run me again. I am stopping in case you still have something
363 valuable there.'
366 if test -n "$interactive_rebase"
367 then
368 type=interactive
369 state_dir="$merge_dir"
370 elif test -n "$do_merge"
371 then
372 type=merge
373 state_dir="$merge_dir"
374 else
375 type=am
376 state_dir="$apply_dir"
379 if test -z "$rebase_root"
380 then
381 case "$#" in
383 if ! upstream_name=$(git rev-parse --symbolic-full-name \
384 --verify -q @{upstream} 2>/dev/null)
385 then
386 . git-parse-remote
387 error_on_missing_default_upstream "rebase" "rebase" \
388 "against" "git rebase <branch>"
391 *) upstream_name="$1"
392 shift
394 esac
395 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
396 die "invalid upstream $upstream_name"
397 upstream_arg="$upstream_name"
398 else
399 test -z "$onto" && die "You must specify --onto when using --root"
400 unset upstream_name
401 unset upstream
402 upstream_arg=--root
405 # Make sure the branch to rebase onto is valid.
406 onto_name=${onto-"$upstream_name"}
407 case "$onto_name" in
408 *...*)
409 if left=${onto_name%...*} right=${onto_name#*...} &&
410 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
411 then
412 case "$onto" in
413 ?*"$LF"?*)
414 die "$onto_name: there are more than one merge bases"
417 die "$onto_name: there is no merge base"
419 esac
420 else
421 die "$onto_name: there is no merge base"
425 onto=$(git rev-parse --verify "${onto_name}^0") ||
426 die "Does not point to a valid commit: $1"
428 esac
430 # If the branch to rebase is given, that is the branch we will rebase
431 # $branch_name -- branch being rebased, or HEAD (already detached)
432 # $orig_head -- commit object name of tip of the branch before rebasing
433 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
434 switch_to=
435 case "$#" in
437 # Is it "rebase other $branchname" or "rebase other $commit"?
438 branch_name="$1"
439 switch_to="$1"
441 if git show-ref --verify --quiet -- "refs/heads/$1" &&
442 orig_head=$(git rev-parse -q --verify "refs/heads/$1")
443 then
444 head_name="refs/heads/$1"
445 elif orig_head=$(git rev-parse -q --verify "$1")
446 then
447 head_name="detached HEAD"
448 else
449 die "fatal: no such branch: $1"
453 # Do not need to switch branches, we are already on it.
454 if branch_name=`git symbolic-ref -q HEAD`
455 then
456 head_name=$branch_name
457 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
458 else
459 head_name="detached HEAD"
460 branch_name=HEAD ;# detached
462 orig_head=$(git rev-parse --verify "${branch_name}^0") || exit
464 esac
466 require_clean_work_tree "rebase" "Please commit or stash them."
468 # Now we are rebasing commits $upstream..$orig_head (or with --root,
469 # everything leading up to $orig_head) on top of $onto
471 # Check if we are already based on $onto with linear history,
472 # but this should be done only when upstream and onto are the same
473 # and if this is not an interactive rebase.
474 mb=$(git merge-base "$onto" "$orig_head")
475 if test "$type" != interactive && test "$upstream" = "$onto" &&
476 test "$mb" = "$onto" &&
477 # linear history?
478 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
479 then
480 if test -z "$force_rebase"
481 then
482 # Lazily switch to the target branch if needed...
483 test -z "$switch_to" || git checkout "$switch_to" --
484 say "Current branch $branch_name is up to date."
485 exit 0
486 else
487 say "Current branch $branch_name is up to date, rebase forced."
491 # If a hook exists, give it a chance to interrupt
492 run_pre_rebase_hook "$upstream_arg" "$@"
494 if test -n "$diffstat"
495 then
496 if test -n "$verbose"
497 then
498 echo "Changes from $mb to $onto:"
500 # We want color (if set), but no pager
501 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
504 test "$type" = interactive && run_specific_rebase
506 # Detach HEAD and reset the tree
507 say "First, rewinding head to replay your work on top of it..."
508 git checkout -q "$onto^0" || die "could not detach HEAD"
509 git update-ref ORIG_HEAD $orig_head
511 # If the $onto is a proper descendant of the tip of the branch, then
512 # we just fast-forwarded.
513 if test "$mb" = "$orig_head"
514 then
515 say "Fast-forwarded $branch_name to $onto_name."
516 move_to_original_branch
517 exit 0
520 if test -n "$rebase_root"
521 then
522 revisions="$onto..$orig_head"
523 else
524 revisions="$upstream..$orig_head"
527 run_specific_rebase